diff --git a/logview/logview-log.h b/logview/logview-log.h
new file mode 100644
index 0000000..cadd1e8
--- /dev/null
+++ b/logview/logview-log.h
@@ -0,0 +1,207 @@
+/*  ----------------------------------------------------------------------
+
+    Copyright (C) 1998  Cesar Miquel  (miquel@df.uba.ar)
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+
+    ---------------------------------------------------------------------- */
+
+#ifndef __LOGVIEW_LOG_H__
+#define __LOGVIEW_LOG_H__
+
+#include <time.h>
+#include <glib.h>
+#include <gtk/gtk.h>
+#include "logview-plugin.h"
+#include "logview-iface.h"
+
+G_BEGIN_DECLS
+
+#define LOGVIEW_TYPE_LOG		(log_get_type ())
+#define LOGVIEW_LOG(obj)		(G_TYPE_CHECK_INSTANCE_CAST((obj), LOGVIEW_TYPE_LOG, Log))
+#define LOGVIEW_LOG_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST((klass), LOGVIEW_TYPE_LOG, LogClass))
+#define LOGVIEW_IS_LOG(obj)		(G_TYPE_CHECK_INSTANCE_TYPE((obj), LOGVIEW_TYPE_LOG))
+#define LOGVIEW_IS_LOG_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), LOGVIEW_TYPE_LOG))
+#define LOGVIEW_LOG_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS((obj), LOGVIEW_TYPE_LOG, LogClass))
+
+typedef struct _Log Log;
+typedef struct _LogClass LogClass;
+typedef struct _LogPrivate LogPrivate;
+
+struct _Log
+{
+	GObject parent;
+	/*< private >*/
+	LogPrivate *prv;
+};
+
+struct _LogClass {
+	GObjectClass parent;
+};
+
+/**
+ * LogProtocol:
+ * @UNKNOWN_LOG: represents the log can't be recognized.
+ * But still has the opportunity to be handled by other plugins.
+ * @BAD_LOG: represents the log is not a log or a bad log.
+ * If in one time a log is marked with this, it's permanently 
+ * ignored and removed from the log name list.
+ * @PLAIN_LOG: a ASCII log.
+ * @GZIP_LOG: a zipped or gzipped log.
+ * @PIPE_LOG: a log can be open by other command.
+ * @USER_DEFINED_LOG: a plugin can define a log protocol for itself, 
+ * e.g. %USER_DEFINED_LOG + 1.
+ */
+typedef enum {
+	UNKNOWN_LOG=0,
+	BAD_LOG,
+	PLAIN_LOG,
+	GZIP_LOG,
+	PIPE_LOG,
+	USER_DEFINED_LOG
+} LogProtocol;
+
+typedef enum {
+	TH_EVENT_EMPTY		= 0,
+	TH_EVENT_INIT_READ	= 1<<1,
+	TH_EVENT_UPDATE		= 1<<2,
+	TH_EVENT_EXIT		= 1<<8
+} ThreadEvent;
+
+/**
+ * Day:
+ * @date: a date, without time value.
+ * @first_line: First line for this day in the log.
+ * @last_line: Last line for this day in the log.
+ * @expand: Collapse all the logs in this @date if %FALSE, else expand all.
+ * @path: Gtk tree path of the day item display in main view of the log.
+ * 
+ * A structure used for grouping and recording the logs by date.
+ */
+typedef struct _Day
+{
+    GDate *date;
+    long first_line, last_line;
+    gboolean expand;
+    GtkTreePath *path;
+} Day;
+
+#define OLD_LOG_NUM	5
+
+/**
+ * log_io:
+ * @log: a #Log instance.
+ * 
+ * Returns: the %PF_LOG_IO type plugin.
+ */
+#define log_io(log)		(LOGVIEW_IFACE_IO (log->prv->ext_data [PF_LOG_IO]))
+
+/**
+ * log_view:
+ * @log: a #Log instance.
+ * 
+ * Returns: the %PF_LOG_VIEW type plugin.
+ */
+#define log_view(log)		(LOGVIEW_IFACE_VIEW (log->prv->ext_data [PF_LOG_VIEW]))
+
+/**
+ * log_name:
+ * @self: a #Log instance.
+ * 
+ * Get the log name.
+ * 
+ * Returns: a constant string which should not be free.
+ */
+
+/**
+ * log_get_protocol:
+ * @self: a #Log instance.
+ * 
+ * Get the #LogProtocol value of self's.
+ * 
+ * Returns: the #LogProtocol value.
+ */
+
+/**
+ * log_set_protocol:
+ * @self: a #Log instance.
+ * @protocol: a #LogProtocol value.
+ * 
+ * Set the #LogProtocol value of self's.
+ */
+
+/**
+ * is_log:
+ * @log: a #Log instance.
+ * 
+ * Determining whether @log is a #Log instance.
+ * 
+ * Returns: TRUE if it is.
+ */
+
+
+/**
+ * log_set_child:
+ * @self: a #Log instance.
+ * @index: the child log id. it should be no less than zero and less #OLD_LOG_NUM
+ * @child: a #Log instance.
+ * 
+ * Access child log instances.
+ */
+void log_set_child (Log *self, gint index, Log *child);
+
+/**
+ * log_get_child:
+ * @self: a #Log instance.
+ * @index: the child log id. it should be no less than zero and less #OLD_LOG_NUM
+ * 
+ * Access child log instances.
+ * 
+ * Returns: the child #Log instance.
+ */
+Log* log_get_child (Log *self, gint index);
+
+/**
+ * log_test_func:
+ * @self: a #Log instance.
+ * @pf: a #PluginFunc index.
+ * 
+ * Returns: if a #pf type plugin is assigned to #self, returns TRUE.
+ */
+gboolean log_test_func (Log *self, PluginFunc pf);
+
+/**
+ * log_set_func:
+ * @self: a #Log instance.
+ * @pf: a #PluginFunc index.
+ * @plugin: a #LogviewPlugin instance.
+ * 
+ * Assign a #pf type plugin to #self.
+ */
+void log_set_func (Log *self, PluginFunc pf, LogviewPlugin *plugin);
+
+void log_notify (Log *self, ThreadEvent te);
+gchar *log_read (Log *self);
+void log_write_line (Log *self, gchar *line);
+void log_write_lines (Log *self, gchar **lines, gint num);
+void log_write_lines_range (Log *self, gchar **lines, gint start, gint end);
+void log_write_date (Log *self, GDate *date);
+void log_write_day (Log *self, Day *day);
+
+extern GType log_get_type (void) G_GNUC_CONST;
+
+G_END_DECLS
+
+#endif /* __LOGVIEW_LOG_H__ */
diff --git a/logview/logview-module.c b/logview/logview-module.c
new file mode 100644
index 0000000..a231ec0
--- /dev/null
+++ b/logview/logview-module.c
@@ -0,0 +1,160 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 8; tab-width: 8 -*- */
+/*
+ * Copyright (C) 2006 Lin Ma <Lin.Ma@sun.com>
+ */
+
+ 
+#include "logview-module.h"
+#include "logview-debug.h"
+
+/* default routines for implement the plugin interfaces */
+static gboolean logview_module_load (LogviewModule* self);
+static void logview_module_unload (LogviewModule* self);
+static void logview_module_class_init (gpointer g_class, gpointer g_class_data);
+static void logview_module_instance_init (GTypeInstance *instance, gpointer g_class);
+
+static GObjectClass *parent_class = NULL;
+
+struct _LogviewModulePrivate {
+	GModule *handle;
+	GType type;
+	LogviewPluginInfo *info;
+};
+
+static void
+module_finalize (LogviewModule* self)
+{
+	g_free (self->prv);
+	parent_class->finalize (G_OBJECT (self));
+}
+
+static void
+logview_module_class_init (gpointer g_class, gpointer g_class_data)
+{
+	GObjectClass *object_class;
+	GTypeModuleClass *self;
+
+	object_class = G_OBJECT_CLASS (g_class);
+	self = G_TYPE_MODULE_CLASS (g_class);
+	parent_class = g_type_class_peek_parent (g_class);
+	object_class->finalize = (void (*)(GObject*)) module_finalize;
+
+	self->load = (gboolean (*)(GTypeModule*)) logview_module_load;
+	self->unload = (void (*)(GTypeModule*)) logview_module_unload;
+}
+
+static void
+logview_module_instance_init (GTypeInstance *instance, gpointer g_class)
+{
+	LogviewModule *self = LOGVIEW_MODULE (instance);
+	self->prv = g_new0 (LogviewModulePrivate, 1);
+}
+
+GType
+logview_module_get_type (void)
+{
+	static GType type = 0;
+	if (type == 0) {
+		static const GTypeInfo info = {
+			/* You fill this structure. */
+			sizeof (LogviewModuleClass),
+			NULL,   /* base_init */
+			NULL,   /* base_finalize */
+			logview_module_class_init,   /* class_init */
+			NULL,   /* class_finalize */
+			NULL,   /* class_data */
+			sizeof (LogviewModule),
+			0,      /* n_preallocs */
+			logview_module_instance_init    /* instance_init */
+		};
+		type = g_type_register_static (G_TYPE_TYPE_MODULE, "LogviewModuleType", &info, 0);
+	}
+	return type;
+}
+
+LogviewModule*
+logview_new_module (const gchar* module_path)
+{
+	LogviewModule* new_module = NULL;
+
+	LV_MARK;
+	g_assert (module_path != NULL);
+	new_module = g_object_new (LOGVIEW_TYPE_MODULE, NULL);
+	g_type_module_set_name (G_TYPE_MODULE (new_module), module_path);
+	return new_module;
+}
+
+LogviewPlugin*
+logview_module_new_plugin (const LogviewModule* self)
+{
+	LogviewPlugin *plugin;
+	LV_MARK;
+	g_assert (self->prv->type != 0);
+	plugin = g_object_new (self->prv->type, NULL);
+	g_assert (LOGVIEW_IS_PLUGIN(plugin));
+	return LOGVIEW_PLUGIN (plugin);
+}
+
+static gboolean
+logview_module_load (LogviewModule* self)
+{
+	GType (*register_logview_plugin)(GTypeModule*);
+	LogviewPluginInfo *(*logview_plugin_info)();
+
+	LV_MARK;
+
+	self->prv->handle = g_module_open (logview_module_name (self), G_MODULE_BIND_LOCAL);
+	if (self->prv->handle !=NULL) {
+		gboolean hit;
+		hit = g_module_symbol (self->prv->handle, "register_logview_plugin", (gpointer*)(&register_logview_plugin));
+		g_return_val_if_fail (hit != FALSE, FALSE);
+		hit = g_module_symbol (self->prv->handle, "logview_plugin_info", (gpointer*)(&logview_plugin_info));
+		g_return_val_if_fail (hit != FALSE, FALSE);
+
+		self->prv->type = (*register_logview_plugin) ((GTypeModule*) self);
+		self->prv->info = (*logview_plugin_info) ();
+		
+		g_return_val_if_fail (self->prv->type != 0, FALSE);
+		g_return_val_if_fail (self->prv->info != NULL, FALSE);
+		return TRUE;
+	}
+	else {
+		LV_ERR ("logview_module_load error: %s", g_module_error());
+	}
+	return FALSE;
+}
+
+static void
+logview_module_unload (LogviewModule* self)
+{
+	LV_MARK;
+	g_module_close (self->prv->handle);
+	self->prv->handle = NULL;
+	self->prv->type = 0;
+	self->prv->info = NULL;
+}
+
+const gchar*
+logview_module_name (LogviewModule *self)
+{
+	g_assert (G_IS_TYPE_MODULE (self));
+	return G_TYPE_MODULE (self)->name;
+}
+
+GType
+logview_module_type (LogviewModule *self)
+{
+	return self->prv->type;
+}
+
+PluginPrio
+logview_module_priority (LogviewModule *self)
+{
+	return self->prv->info->prio;
+}
+
+const gchar*
+logview_module_desc (LogviewModule *self)
+{
+	return self->prv->info->desc;
+}
diff --git a/logview/logview-module.h b/logview/logview-module.h
new file mode 100644
index 0000000..52fe388
--- /dev/null
+++ b/logview/logview-module.h
@@ -0,0 +1,50 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 8; tab-width: 8 -*- */
+/*
+ * Copyright (C) 2006 Lin Ma <Lin.Ma@sun.com>
+ */
+
+#ifndef __LOGVIEW_MODULE_H__
+#define __LOGVIEW_MODULE_H__
+
+#include <glib-object.h>
+#include <gmodule.h>
+#include "logview-plugin.h"
+
+#define LOGVIEW_TYPE_MODULE		(logview_module_get_type ())
+#define LOGVIEW_MODULE(obj)		(G_TYPE_CHECK_INSTANCE_CAST ((obj), LOGVIEW_TYPE_MODULE, LogviewModule))
+#define LOGVIEW_MODULE_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST ((klass), LOGVIEW_TYPE_MODULE, LogviewModuleClass))
+#define LOGVIEW_IS_MODULE(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), LOGVIEW_TYPE_MODULE))
+#define LOGVIEW_IS_MODULE_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), LOGVIEW_TYPE_MODULE))
+#define LOGVIEW_MODULE_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS ((obj), LOGVIEW_TYPE_MODULE, LogviewModuleClass))
+
+typedef struct _LogviewModule LogviewModule;
+typedef struct _LogviewModuleClass LogviewModuleClass;
+typedef struct _LogviewModulePrivate LogviewModulePrivate;
+
+struct _LogviewModule{
+	GTypeModule parent;
+	/* instance members */
+/* private */
+	LogviewModulePrivate *prv;
+};
+
+struct _LogviewModuleClass {
+	GTypeModuleClass parent;
+	/* class members */
+};
+
+
+/* For the core application which should implemete the level to call plugins */
+GType logview_module_get_type (void);
+/* return the name of the module, should not be freed */
+const gchar* logview_module_name (LogviewModule *self);
+GType logview_module_type (LogviewModule *self);
+PluginPrio logview_module_priority (LogviewModule *self);
+const gchar* logview_module_desc (LogviewModule *self);
+/* return a new module */
+LogviewModule* logview_new_module (const gchar* module_path);
+/* return a new plugin */
+LogviewPlugin* logview_module_new_plugin (const LogviewModule* self);
+
+#endif /* __LOGVIEW_MODULE_H__ */
+
diff --git a/logview/logview-plugin-list.c b/logview/logview-plugin-list.c
new file mode 100644
index 0000000..3b79b02
--- /dev/null
+++ b/logview/logview-plugin-list.c
@@ -0,0 +1,280 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 8; tab-width: 8 -*- */
+/*
+ * Copyright (C) 2006 Lin Ma <Lin.Ma@sun.com>
+ */
+
+#ifdef HAVE_CONFIG_H
+#  include <config.h>
+#endif
+
+#include <glib/gi18n.h>
+#include "logview-plugin-list.h"
+#include "logview-plugin-manager.h"
+#include "logview-module.h"
+#include "misc.h"
+
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <unistd.h>
+#include <string.h>
+#include <stdio.h>
+#include <gdk/gdkkeysyms.h>
+#include <gtk/gtk.h>
+
+static void logview_plugin_list_init (LogviewPluginList *plugin_list);
+
+#define GLADE_HOOKUP_OBJECT(component,widget,name) \
+  g_object_set_data_full (G_OBJECT (component), name, \
+    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)
+
+#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
+  g_object_set_data (G_OBJECT (component), name, widget)
+
+enum {
+	NAME_COL,
+	PRI_COL,
+	DESC_COL,
+	PATH_COL,
+	N_COLS
+};
+
+static void
+logview_plugin_list_sync_cb (const LogviewModule *module, gpointer data)
+{
+	GtkTreeIter iter;
+	gchar *name, *desc, *path;
+	gint pri;
+	LogviewPluginList *self = (LogviewPluginList*)data;
+
+	path = logview_module_name (module);
+	pri = logview_module_priority (module);
+	desc = logview_module_desc (module);
+	name = log_extract_filename (path);
+
+	gtk_tree_store_append (self->list, &iter, NULL);
+	gtk_tree_store_set (self->list, &iter,
+			    NAME_COL, name,
+			    PRI_COL, pri,
+			    DESC_COL, desc,
+			    PATH_COL, path,
+			    -1);
+	g_free (name);
+}
+
+static void
+logview_plugin_list_sync (LogviewPluginList *self)
+{
+	gtk_widget_hide_all (self->scrolledwindow);
+	gtk_widget_hide_all (self->label);
+	gtk_tree_store_clear (self->list);
+	if (pluginmgr_plugin_amount () > 0) {
+		pluginmgr_modules_iterate (logview_plugin_list_sync_cb, self);
+		gtk_widget_show_all (self->scrolledwindow);
+	}
+	else
+		gtk_widget_show_all (self->label);
+
+}
+
+void
+logview_plugin_list_show (LogviewPluginList *self, GtkWidget *window)
+{
+	g_return_if_fail (GTK_IS_WINDOW (window));
+	gtk_widget_show_all (self->dialog);
+	logview_plugin_list_sync (self);
+}
+
+static gint
+logview_plugin_list_cmp (GtkTreeModel *model,
+			    GtkTreeIter *a,
+			    GtkTreeIter *b,
+			    gpointer user_data)
+{
+	gint col_id = GPOINTER_TO_INT(user_data);
+	gint ret;
+
+	switch (col_id) {
+	case PATH_COL:
+	case NAME_COL: {
+		gchar *stra, *strb;
+		gtk_tree_model_get (model, a, (gint)user_data, &stra, -1);
+		gtk_tree_model_get (model, b, (gint)user_data, &strb, -1);
+		ret = g_ascii_strcasecmp (stra, strb);
+		g_free (stra);
+		g_free (strb);
+	}
+		break;
+	case PRI_COL: {
+		gint ia, ib;
+		gtk_tree_model_get (model, a, (gint)user_data, &ia, -1);
+		gtk_tree_model_get (model, b, (gint)user_data, &ib, -1);
+		ret = ia - ib;
+	}
+		break;
+	default:
+		g_assert_not_reached ();
+	}
+	return ret;
+}
+
+static void
+logview_plugin_list_init (LogviewPluginList *self)
+{
+	GtkWidget *dialog_vbox3;
+	GtkWidget *dialog_action_area3;
+	GtkWidget *exist_button;
+	GtkTreeViewColumn *name_col, *pri_col, *path_col, *desc_col;
+	GtkCellRenderer *text_renderer;
+	GtkWidget *view;
+
+	self->list = gtk_tree_store_new (N_COLS,
+					 G_TYPE_STRING,
+					 G_TYPE_INT,
+					 G_TYPE_STRING,
+					 G_TYPE_STRING);
+	text_renderer = gtk_cell_renderer_text_new ();
+
+	view = g_object_new (GTK_TYPE_TREE_VIEW,
+			     "model", self->list,
+			     "rules-hint", TRUE,
+			     "headers-clickable", TRUE,
+			     "reorderable", TRUE,
+			     NULL);
+
+	name_col = gtk_tree_view_column_new_with_attributes (_("Plugin Name"),
+							     text_renderer,
+							     "text", NAME_COL,
+							     NULL);
+	gtk_tree_view_column_set_sort_column_id (name_col, NAME_COL);
+
+	g_object_set (name_col,
+		      "resizable", TRUE,
+		      "clickable", TRUE,
+		      "sort-indicator", TRUE,
+		      "reorderable", TRUE,
+		      NULL);
+	pri_col = gtk_tree_view_column_new_with_attributes (_("Priority"),
+							     text_renderer,
+							     "text", PRI_COL,
+							     NULL);
+	gtk_tree_view_column_set_sort_column_id (pri_col, PRI_COL);
+
+	g_object_set (pri_col,
+		      "resizable", TRUE,
+		      "clickable", TRUE,
+		      "sort-indicator", TRUE,
+		      "reorderable", TRUE,
+		      NULL);
+	desc_col = gtk_tree_view_column_new_with_attributes (_("Description"),
+							     text_renderer,
+							     "text", DESC_COL,
+							     NULL);
+	g_object_set (desc_col,
+		      "resizable", TRUE,
+		      "reorderable", TRUE,
+		      NULL);
+
+	path_col = gtk_tree_view_column_new_with_attributes (_("Path"),
+							     text_renderer,
+							     "text", PATH_COL,
+							     NULL);
+	g_object_set (path_col,
+		      "resizable", TRUE,
+		      "clickable", TRUE,
+		      "sort-indicator", TRUE,
+		      "reorderable", TRUE,
+		      NULL);
+	gtk_tree_view_column_set_sort_column_id (path_col, PATH_COL);
+
+	gtk_tree_sortable_set_sort_func	(GTK_TREE_SORTABLE(self->list),
+					 NAME_COL,
+					 (GtkTreeIterCompareFunc) logview_plugin_list_cmp,
+					 GINT_TO_POINTER(NAME_COL),
+					 NULL);
+	gtk_tree_sortable_set_sort_func	(GTK_TREE_SORTABLE(self->list),
+					 PATH_COL,
+					 (GtkTreeIterCompareFunc) logview_plugin_list_cmp,
+					 GINT_TO_POINTER(PATH_COL),
+					 NULL);
+	gtk_tree_sortable_set_sort_func	(GTK_TREE_SORTABLE(self->list),
+					 PRI_COL,
+					 (GtkTreeIterCompareFunc) logview_plugin_list_cmp,
+					 GINT_TO_POINTER(PRI_COL),
+					 NULL);
+	gtk_tree_sortable_set_sort_column_id (GTK_TREE_SORTABLE(self->list), NAME_COL, GTK_SORT_ASCENDING);
+
+	gtk_tree_view_append_column (view, name_col);
+	gtk_tree_view_append_column (view, pri_col);
+	gtk_tree_view_append_column (view, desc_col);
+	gtk_tree_view_append_column (view, path_col);
+
+	self->dialog = gtk_dialog_new ();
+	gtk_dialog_set_has_separator (GTK_DIALOG (self->dialog), FALSE);
+	gtk_widget_set_size_request (self->dialog, 800, 400);
+	gtk_window_set_destroy_with_parent (GTK_WINDOW (self->dialog), TRUE);
+	gtk_window_set_title (GTK_WINDOW (self->dialog), _("Log Viewer Plugins"));
+	gtk_window_set_position (GTK_WINDOW (self->dialog),
+				 GTK_WIN_POS_CENTER_ON_PARENT);
+	gtk_window_set_modal (GTK_WINDOW (self->dialog), TRUE);
+	gtk_window_set_resizable (GTK_WINDOW (self->dialog), TRUE);
+	gtk_window_set_type_hint (GTK_WINDOW (self->dialog),
+				  GDK_WINDOW_TYPE_HINT_DIALOG);
+	gtk_window_set_skip_taskbar_hint (GTK_WINDOW (self->dialog), TRUE);
+
+	dialog_vbox3 = GTK_DIALOG (self->dialog)->vbox;
+
+	self->label = gtk_label_new (_("No plugins installed!"));
+	gtk_widget_show (self->label);
+	gtk_box_pack_start (GTK_BOX (dialog_vbox3), self->label, TRUE, TRUE, 0);
+
+	self->scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
+	gtk_box_pack_start (GTK_BOX (dialog_vbox3), self->scrolledwindow,
+			    TRUE, TRUE, 0);
+	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (self->scrolledwindow),
+					GTK_POLICY_AUTOMATIC,
+					GTK_POLICY_AUTOMATIC);
+	gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (self->scrolledwindow),
+					     GTK_SHADOW_NONE);
+	gtk_container_add (GTK_CONTAINER (self->scrolledwindow), view);
+
+	dialog_action_area3 = GTK_DIALOG (self->dialog)->action_area;
+	gtk_container_set_border_width (GTK_CONTAINER (self->scrolledwindow), 12);
+	gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area3),
+				   GTK_BUTTONBOX_END);
+
+	exist_button = gtk_button_new_from_stock ("gtk-close");
+	gtk_dialog_add_action_widget (GTK_DIALOG (self->dialog),
+				      exist_button, GTK_RESPONSE_CLOSE);
+	GTK_WIDGET_SET_FLAGS (exist_button, GTK_CAN_DEFAULT);
+
+	/* Store pointers to all widgets, for use by lookup_widget(). */
+	GLADE_HOOKUP_OBJECT_NO_REF (self->dialog, dialog_vbox3, "dialog_vbox3");
+	GLADE_HOOKUP_OBJECT (self->dialog, self->scrolledwindow, "scrolledwindow");
+	GLADE_HOOKUP_OBJECT (self->dialog, view, "treeview1");
+	GLADE_HOOKUP_OBJECT_NO_REF (self->dialog, dialog_action_area3, "dialog_action_area3");
+	GLADE_HOOKUP_OBJECT (self->dialog, exist_button, "exist_button");
+	GLADE_HOOKUP_OBJECT (self->dialog, self->label, "label1");
+
+	g_signal_connect_swapped (exist_button, "clicked",
+				  G_CALLBACK(gtk_widget_hide_all),
+				  self->dialog);
+	g_signal_connect_swapped (self->dialog, "delete-event",
+				  G_CALLBACK(gtk_widget_hide_on_delete),
+				  self->dialog);
+
+}
+
+LogviewPluginList *
+logview_plugin_list_new (void)
+{
+	LogviewPluginList * list;
+	list = g_new0 (LogviewPluginList, 1);
+	logview_plugin_list_init (list);
+	return list;
+}
+
+void
+logview_plugin_list_delete (LogviewPluginList * list)
+{
+	g_free (list);
+}
diff --git a/logview/logview-plugin-list.h b/logview/logview-plugin-list.h
new file mode 100644
index 0000000..64a0d98
--- /dev/null
+++ b/logview/logview-plugin-list.h
@@ -0,0 +1,23 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 8; tab-width: 8 -*- */
+/*
+ * Copyright (C) 2006 Lin Ma <Lin.Ma@sun.com>
+ */
+
+#ifndef __LOGVIEW_PLUGIN_LIST_H__
+#define __LOGVIEW_PLUGIN_LIST_H__
+
+#include <gtk/gtk.h>
+
+typedef struct _LogviewPluginList LogviewPluginList;
+struct _LogviewPluginList {
+	GtkTreeStore *list;
+	GtkWidget *scrolledwindow;
+	GtkWidget *label;
+	GtkWidget *dialog;
+};
+
+void logview_plugin_list_show (LogviewPluginList *self, GtkWidget *window);
+LogviewPluginList *logview_plugin_list_new (void);
+void logview_plugin_list_delete (LogviewPluginList *);
+
+#endif /* __LOGVIEW_PLUGIN_LIST_H__ */
